<html>
<head>
<title>OgreSkeletonFileFormat.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSkeletonFileFormat.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSkeletonFileFormat_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __SkeletonFileFormat_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __SkeletonFileFormat_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00034"></a>00034 
<a name="l00055"></a><a class="code" href="group__Animation.html#ga5b37bdf2f67384dbd81643164545f7bd">00055</a>     <span class="keyword">enum</span> <a class="code" href="group__Animation.html#ga5b37bdf2f67384dbd81643164545f7bd" title="Definition of the OGRE .skeleton file format.">SkeletonChunkID</a> {
<a name="l00056"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda7ed2511945645204fe9f7423e32aea49">00056</a>         <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda7ed2511945645204fe9f7423e32aea49">SKELETON_HEADER</a>            = 0x1000,
<a name="l00057"></a>00057             <span class="comment">// char* version           : Version number check</span>
<a name="l00058"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdad777591f3958da3716318eb820bbcab8">00058</a>             <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdad777591f3958da3716318eb820bbcab8">SKELETON_BLENDMODE</a>         = 0x1010, <span class="comment">// optional</span>
<a name="l00059"></a>00059                 <span class="comment">// unsigned short blendmode     : SkeletonAnimationBlendMode</span>
<a name="l00060"></a>00060         
<a name="l00061"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaacf798731cab07af608a45eb331faa01">00061</a>         <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaacf798731cab07af608a45eb331faa01">SKELETON_BONE</a>              = 0x2000,
<a name="l00062"></a>00062         <span class="comment">// Repeating section defining each bone in the system. </span>
<a name="l00063"></a>00063         <span class="comment">// Bones are assigned indexes automatically based on their order of declaration</span>
<a name="l00064"></a>00064         <span class="comment">// starting with 0.</span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066             <span class="comment">// char* name                       : name of the bone</span>
<a name="l00067"></a>00067             <span class="comment">// unsigned short handle            : handle of the bone, should be contiguous &amp; start at 0</span>
<a name="l00068"></a>00068             <span class="comment">// Vector3 position                 : position of this bone relative to parent </span>
<a name="l00069"></a>00069             <span class="comment">// Quaternion orientation           : orientation of this bone relative to parent </span>
<a name="l00070"></a>00070             <span class="comment">// Vector3 scale                    : scale of this bone relative to parent </span>
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda60d951d9cd1e76668758a78eaa75e3af">00072</a>         <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda60d951d9cd1e76668758a78eaa75e3af">SKELETON_BONE_PARENT</a>       = 0x3000,
<a name="l00073"></a>00073         <span class="comment">// Record of the parent of a single bone, used to build the node tree</span>
<a name="l00074"></a>00074         <span class="comment">// Repeating section, listed in Bone Index order, one per Bone</span>
<a name="l00075"></a>00075 
<a name="l00076"></a>00076             <span class="comment">// unsigned short handle             : child bone</span>
<a name="l00077"></a>00077             <span class="comment">// unsigned short parentHandle   : parent bone</span>
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaa559ee7367718e8c9ffdfd1af83c9ca8">00079</a>         <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaa559ee7367718e8c9ffdfd1af83c9ca8">SKELETON_ANIMATION</a>         = 0x4000,
<a name="l00080"></a>00080         <span class="comment">// A single animation for this skeleton</span>
<a name="l00081"></a>00081 
<a name="l00082"></a>00082             <span class="comment">// char* name                       : Name of the animation</span>
<a name="l00083"></a>00083             <span class="comment">// float length                      : Length of the animation in seconds</span>
<a name="l00084"></a>00084         
<a name="l00085"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaedacebfaa34fe1ed9b95efb6210e13e1">00085</a>             <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaedacebfaa34fe1ed9b95efb6210e13e1">SKELETON_ANIMATION_BASEINFO</a> = 0x4010,
<a name="l00086"></a>00086             <span class="comment">// [Optional] base keyframe information</span>
<a name="l00087"></a>00087             <span class="comment">// char* baseAnimationName (blank for self)</span>
<a name="l00088"></a>00088             <span class="comment">// float baseKeyFrameTime</span>
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda691013153a33fde3a543deed39382c20">00090</a>             <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda691013153a33fde3a543deed39382c20">SKELETON_ANIMATION_TRACK</a> = 0x4100,
<a name="l00091"></a>00091             <span class="comment">// A single animation track (relates to a single bone)</span>
<a name="l00092"></a>00092             <span class="comment">// Repeating section (within SKELETON_ANIMATION)</span>
<a name="l00093"></a>00093                 
<a name="l00094"></a>00094                 <span class="comment">// unsigned short boneIndex     : Index of bone to apply to</span>
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaebf5354fd4093986740b6f7a0b9c998e">00096</a>                 <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaebf5354fd4093986740b6f7a0b9c998e">SKELETON_ANIMATION_TRACK_KEYFRAME</a> = 0x4110,
<a name="l00097"></a>00097                 <span class="comment">// A single keyframe within the track</span>
<a name="l00098"></a>00098                 <span class="comment">// Repeating section</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100                     <span class="comment">// float time                    : The time position (seconds)</span>
<a name="l00101"></a>00101                     <span class="comment">// Quaternion rotate            : Rotation to apply at this keyframe</span>
<a name="l00102"></a>00102                     <span class="comment">// Vector3 translate            : Translation to apply at this keyframe</span>
<a name="l00103"></a>00103                     <span class="comment">// Vector3 scale                : Scale to apply at this keyframe</span>
<a name="l00104"></a><a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda869ed880064984ab52e95a922efec6cd">00104</a>         <a class="code" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda869ed880064984ab52e95a922efec6cd">SKELETON_ANIMATION_LINK</a>         = 0x5000
<a name="l00105"></a>00105         <span class="comment">// Link to another skeleton, to re-use its animations</span>
<a name="l00106"></a>00106 
<a name="l00107"></a>00107             <span class="comment">// char* skeletonName                   : name of skeleton to get animations from</span>
<a name="l00108"></a>00108             <span class="comment">// float scale                          : scale to apply to trans/scale keys</span>
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     };
<a name="l00114"></a>00114 } <span class="comment">// namespace</span>
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
